function [cntArr30x100] = makeCntArr30x100(corArr12, startClick0, endClick0)
    
    % Tar inn corArr12 for å få clock0 tider
    
    % Generer geno
    % generer paraArr for sample 30 fps
    
    %
    
    
    
    corArr12_30x100 = genCorArr12_30x100(corArr12, startClick0, endClick0);
    
    corArr12_30x100 = addPara(corArr12_30x100);
    
    cntArr30x100 = makeCntArr30(corArr12_30x100);
    
    %figure(3);clf;plot(cntArr30x100(:,1),'color',[0 0 1]);hold on;plot(cntArr30x100(:,2),'color',[1 0 0]);hold on;
    
end

%%
function [cntArr30x100] = makeCntArr30(corArr12_30x100)
    % Her samples med 30hz
    
    fN = 30;
    
    endTime = corArr12_30x100(end, 1, 1);
    antSampl = floor(fN*endTime/1000);
    
    cntArr30x100 = zeros(antSampl, 2, 10);
    
    paraArr12 = corArr12_30x100(:, 4:11, :);
    clickArr12 = corArr12_30x100(:, 1, 1); % Tider for para val i ms  start shift til 0
    
    for indi = 1 : 10
        paraIndexTeller = 1;
        A = 0;
        B = 0;
        D = 0;
        T = 1;
        % Kanal 1
        for sNr = 1 : size(cntArr30x100, 1) % sampleNr
            if paraIndexTeller <= size(paraArr12, 1)
                if sNr > fN*clickArr12(paraIndexTeller)/1000 % click2sNr, interpolerer, og legger inn ny keyframe når behov
                    A = paraArr12(paraIndexTeller, 1, indi);
                    B = paraArr12(paraIndexTeller, 2, indi);
                    D = paraArr12(paraIndexTeller, 3, indi);
                    T = paraArr12(paraIndexTeller, 4, indi);
                    
                    paraIndexTeller = paraIndexTeller + 1;
                end
            end
            
            cntArr30x100(sNr, 1, indi) = A*cos(2*pi*(sNr - D)/T) + B;
        end
    end
    
    for indi = 1 : 10
        paraIndexTeller = 1;
        A = 0;
        B = 0;
        D = 0;
        T = 1;
        % Kanal 2
        for sNr = 1 : size(cntArr30x100, 1) % sampleNr
            if paraIndexTeller <= size(paraArr12, 1)
                if sNr > fN*clickArr12(paraIndexTeller)/1000 % click2sNr, interpolerer, og legger inn ny keyframe når behov
                    A = paraArr12(paraIndexTeller, 1+4, indi);
                    B = paraArr12(paraIndexTeller, 2+4, indi);
                    D = paraArr12(paraIndexTeller, 3+4, indi);
                    T = paraArr12(paraIndexTeller, 4+4, indi);
                    
                    paraIndexTeller = paraIndexTeller + 1;
                end
            end
            
            cntArr30x100(sNr, 2, indi) = A*cos(2*pi*(sNr - D)/T) + B;
        end
    end
end

%%
function [corArr12_30x100] = addPara(corArr12_30x100)
    
    % Først kanal 1
    for indi = 1 : 10
        currYval = 0;
        currClick = 1;
        for i = 1 : size(corArr12_30x100, 1)
            if corArr12_30x100(i, 2, indi) > 0 % Har funnet en ny start/slutt verdi
                oldYval = currYval;
                oldClick = currClick;
                currYval = (corArr12_30x100(i, 2, indi) - 5)/4; % Legger inn ny Y verdi sentrert rundt 5 i currclick i
                currClick = i;
                
                x1 = corArr12_30x100(oldClick, 1, indi); % x til click-1
                x2 = corArr12_30x100(currClick, 1, indi);
                y1 = oldYval;
                y2 = currYval;
                
                [A, B, D, T] = findPara30(x1, y1, x2, y2);
                for ii = oldClick : currClick - 1
                    corArr12_30x100(ii, 4:7, indi) = [A, B, D, T];
                end
            end
        end
    end
    
    % Så kanal 2
    for indi = 1 : 10
        currYval = 0;
        currClick = 1;
        for i = 1 : size(corArr12_30x100, 1)
            if corArr12_30x100(i, 3, indi) > 0 % Har funnet en ny start/slutt verdi
                oldYval = currYval;
                oldClick = currClick;
                currYval = (corArr12_30x100(i, 3, indi) - 5)/4; % Legger inn ny Y verdi sentrert rundt 5 i currclick i
                currClick = i;
                
                x1 = corArr12_30x100(oldClick, 1, indi); % x til click-1
                x2 = corArr12_30x100(currClick, 1, indi);
                y1 = oldYval;
                y2 = currYval;
                
                [A, B, D, T] = findPara30(x1, y1, x2, y2);
                for ii = oldClick : currClick - 1
                    corArr12_30x100(ii, 4+4:7+4, indi) = [A, B, D, T];
                end
            end
        end
    end
    
end

%%
function [corArr12_30x100] = genCorArr12_30x100(corArr12, startClick0, endClick0)
    % Lager kun tider og 1-9 val, der tider shiftes ned mot 0
    %
    % 2 kanaler med (0)1-9, 100 indiv
    % random gen
    % prob 0.1 for keyframe på en click12
    % prob 0.3 for keyframe på en click0
    % 3 (click12) min avstand mellom keyframes
    
    prob0 = 1 - 0.7;
    prob12 = 1 - 0.001;
    
    antKey12frames = 12 * (endClick0 - startClick0 + 1);
    
    corArr12_30x100 = zeros(antKey12frames, 1+2+2*4, 10);
    
    old = 0;
    oldOld = 0;
    for indiv = 1 : 10
        for ch = 1 : 2
            corArr12_30x100(1, ch+1, indiv) = 5; % Starter på 5, men kan overskrives under
            corArr12_30x100(end, ch+1, indiv) = 5; % Slutter på 5, men kan overskrives under
            for key = 1 : antKey12frames
                if old == 0 && oldOld == 0 % 3 (click12) min avstand mellom keyframes
                    if mod(key-1, 12) == 0 % er click0 frame
                        if rand(1) > prob0
                            corArr12_30x100(key, ch+1, indiv) = floor(rand(1)*9 + 1);
                        end
                    else % er click12 frame
                        if rand(1) > prob12
                            corArr12_30x100(key, ch+1, indiv) = floor(rand(1)*9 + 1);
                        end
                    end
                end
                oldOld = old;
                old = corArr12_30x100(key, ch+1, indiv);
            end
        end
    end
    
    % click12offsett
    click12offsett =  12 * (startClick0 - 1) + 1;
    
    % Klipper inn tider fra orginal
    klipp2D = corArr12(click12offsett : click12offsett + antKey12frames - 1, 1);
    klipp3D = repmat(klipp2D, 1, 1, 10);
    corArr12_30x100(1:end, 1, :) = klipp3D;
    
    % Shifter rider mot 0
    corArr12_30x100(:, 1, :) = corArr12_30x100(:, 1, :) - corArr12_30x100(1, 1, 1);
    
end

%%

function [a, b, d, T] = findPara30(x1, y1, x2, y2)
    % y = a*cos(2*pi*(t-d)/T) + b
    
    fs = 30;
    
    T = 2*fs*(x2 - x1)/1000; % ms
    a = (y1 - y2)/2;
    b = mean([y1 y2]);
    d = fs*x1/1000;
    
end








